;Tutorial 9.4 - Nigel Goodwin 2003
;Sony SIRC IR transmitter with HEX keypad
	LIST	p=16F628		;tell assembler what chip we are using
	include "P16F628.inc"		;include the defaults for the chip
	__config 0x3D18			;sets the configuration settings (oscillator type etc.)

	cblock 	0x20 			;start of general purpose registers
		count1 			;used in delay routine
		counta 			;used in delay routine 
		countb
		count
		key
		rows
		index
		Delay_Count
		Bit_Cntr
		Data_Byte
		Dev_Byte
		Rcv_Byte
		Pulse
	endc
	

IR_PORT	Equ	PORTA
IR_TRIS	Equ	TRISA
IR_Out	Equ	0x01
IR_In	Equ	0x02
KEY_PORT	Equ	PORTB			;keypad port
KEY_TRIS	Equ	TRISB
Col1		Equ	0			;pins used for keypad inputs
Col2		Equ	1
Col3		Equ	2
Col4		Equ	3

TV_ID		Equ	0x01			;TV device ID

But1		Equ	0x00			;numeric button ID's
But2		Equ	0x01
But3		Equ	0x02
But4		Equ	0x03
But5		Equ	0x04
But6		Equ	0x05
But7		Equ	0x06
But8		Equ	0x07
But9		Equ	0x08
But0		Equ	0x09
ProgUp		Equ	d'16'
ProgDn		Equ	d'17'
VolUp		Equ	d'18'
VolDn		Equ	d'19'
Mute		Equ	d'20'
Power		Equ	d'21'


	org	0x0000			;org sets the origin, 0x0000 for the 16F628,
	goto	Start			;this is where the program starts running

	org	0x005	

Start		movlw	0x07
		movwf	CMCON			;turn comparators off (make it like a 16F84)

		clrf	IR_PORT			;make IR Port outputs low
 	

   		bsf 	STATUS,		RP0	;select bank 1
   		movlw 	b'11111101'		;set IR Port all inputs, except RB1
   		movwf 	IR_TRIS
		movlw	0x0F			;set keypad pins
		movwf	KEY_TRIS		;half in, half out
		bcf	STATUS,		RP0	;select bank 0
		movlw	0x00
		movwf	key			;set inital key to non repeating one

Loop		call	Keys
		andlw	0x0f			;make sure 0-15
		addwf   PCL       , f		;and jump to key
		goto	SwitchC
		goto	SwitchB
		goto	Switch0
		goto	SwitchA
		goto	SwitchD
		goto	Switch9
		goto	Switch8
		goto	Switch7
		goto	SwitchE
		goto	Switch6
		goto	Switch5
		goto	Switch4
		goto	SwitchF
		goto	Switch3
		goto	Switch2
		goto	Switch1
Done		call	Delay27
		goto	Loop

Switch1		movlw	But1
		call	Xmit_RS232
		Goto	Done

Switch2		movlw	But2
		call	Xmit_RS232
		Goto	Done

Switch3		movlw	But3
		call	Xmit_RS232
		Goto	Done

Switch4		movlw	But4
		call	Xmit_RS232
		Goto	Done

Switch5		movlw	But5
		call	Xmit_RS232
		Goto	Done

Switch6		movlw	But6
		call	Xmit_RS232
		Goto	Done

Switch7		movlw	But7
		call	Xmit_RS232
		Goto	Done

Switch8		movlw	But8
		call	Xmit_RS232
		Goto	Done

Switch9		movlw	But9
		call	Xmit_RS232
		Goto	Done

Switch0		movlw	But0
		call	Xmit_RS232
		Goto	Done

SwitchA		movlw	VolUp
		call	Xmit_RS232
		Goto	Done

SwitchB		movlw	VolDn
		call	Xmit_RS232
		Goto	Done

SwitchC		movlw	ProgUp
		call	Xmit_RS232
		Goto	Done

SwitchD		movlw	ProgDn
		call	Xmit_RS232
		Goto	Done

SwitchE		movlw	Mute
		call	Xmit_RS232
		Goto	Done

SwitchF		movlw	Power
		call	Xmit_RS232
		Goto	Done

;Keypad subroutines

Keys	  	call    Scan_Keys
            	movlw   0x10			;check for no key pressed
            	subwf   key, w
            	btfss   STATUS, Z
            	goto    Key_Found
		call	Delay20
		goto	Keys
Key_Found      	movf    key, w	
		return				;key pressed now in W

Scan_Keys  	clrf    key
		movlw	0xF0			;set all output lines high
            	movwf   KEY_PORT
            	movlw   0x04
            	movwf   rows			;set number of rows
            	bcf     STATUS, C		;put a 0 into carry
Scan	  	rrf     KEY_PORT, f
            	bsf     STATUS, C		;follow the zero with ones
;comment out next two lines for 4x3 numeric keypad.
            	btfss   KEY_PORT, Col4
            	goto    Press
            	incf    key, f
            	btfss   KEY_PORT, Col3
            	goto    Press
            	incf    key, f
            	btfss   KEY_PORT, Col2
            	goto    Press
            	incf    key, f
            	btfss   KEY_PORT, Col1
            	goto    Press
            	incf    key, f
            	decfsz  rows, f
            	goto    Scan
Press	  	return

;end of keypad subroutines.

TX_Start	movlw	d'92'
		call	IR_pulse
		movlw	d'23'
		call	NO_pulse
		retlw	0x00

TX_One		movlw	d'46'
		call	IR_pulse
		movlw	d'23'
		call	NO_pulse
		retlw	0x00

TX_Zero		movlw	d'23'
		call	IR_pulse
		movlw	d'23'
		call	NO_pulse
		retlw	0x00


IR_pulse			 	
		MOVWF	count		;  Pulses the IR led at 38KHz
irloop		BSF	IR_PORT,	IR_Out 
		NOP			;
		NOP			;
		NOP			;
		NOP			; 
		NOP			;
		NOP			;
		NOP			;
		BCF	IR_PORT,	IR_Out
		NOP			;
		NOP			;
		NOP			;
		NOP			;
		NOP			;
		NOP			;	
		NOP			;
		NOP			;	
		NOP			;
		NOP			;
		NOP
		NOP
		NOP			;
		NOP			;
		DECFSZ	count,F
		GOTO 	irloop	
		RETLW	0

NO_pulse			 	
		MOVWF	count		;  Doesn't pulse the IR led
irloop2		BCF	IR_PORT,	IR_Out 
		NOP			;
		NOP			;
		NOP			;
		NOP			;
		NOP			;
		NOP			;
		NOP			;
		NOP			; 
		NOP			;
		NOP			;
		NOP			;
		BCF	IR_PORT,	IR_Out
		NOP			;
		NOP			;	
		NOP			;
		NOP			;	
		NOP			;
		NOP			;
		NOP
		NOP
		NOP			;
		NOP			;
		DECFSZ	count,F
		GOTO 	irloop2	
		RETLW	0

Xmit_RS232      MOVWF   Data_Byte            	;move W to Data_Byte
                MOVLW   0x07                 	;set 7 DATA bits out
                MOVWF   Bit_Cntr
                call	TX_Start		;send start bit
Ser_Loop        RRF     Data_Byte , f        	;send one bit
                BTFSC   STATUS    , C
                call	TX_One
                BTFSS   STATUS    , C
                call	TX_Zero
                DECFSZ  Bit_Cntr  , f        	;test if all done
                GOTO    Ser_Loop
						;now send device data
		movlw	D'1'
		movwf	Dev_Byte		;set device to TV
		MOVLW   0x05                 	;set 5 device bits out
                MOVWF   Bit_Cntr
Ser_Loop2       RRF     Dev_Byte , f        	;send one bit
                BTFSC   STATUS    , C
                call	TX_One
                BTFSS   STATUS    , C
                call	TX_Zero
                DECFSZ  Bit_Cntr  , f        	;test if all done
                GOTO    Ser_Loop2
                retlw	0x00



;Delay routines

Delay255	movlw	0xff		;delay 255 mS
		goto	d0
Delay100	movlw	d'100'		;delay 100mS
		goto	d0
Delay50		movlw	d'50'		;delay 50mS
		goto	d0
Delay27		movlw	d'27'		;delay 27mS
		goto	d0
Delay20		movlw	d'20'		;delay 20mS
		goto	d0
Delay5		movlw	0x05		;delay 5.000 ms (4 MHz clock)
d0		movwf	count1
d1		movlw	0xC7
		movwf	counta
		movlw	0x01
		movwf	countb
Delay_0		decfsz	counta, f
		goto	$+2
		decfsz	countb, f
		goto	Delay_0

		decfsz	count1	,f
		goto	d1
		retlw	0x00

;end of Delay routines

	end